Subject: Re: [PATCH RFC 02/10] dpaa_eth: add support for DPAA Ethernet

From: Joakim Tjernlund <[email-masked]>
Date: Mon, 20 Jul 2015 12:46:37 +0000

On Mon, 2015-07-20 at 12:18 +0000, Madalin-Cristian Bucur wrote:
> Hi Joakim
> 
> > -----Original Message-----
> > From: Joakim Tjernlund [mailto:[email-masked]]
> > Sent: Monday, July 20, 2015 10:57 AM
> > To: [email-masked]; [email-masked]; Bucur Madalin-
> > Cristian-B32716
> > Cc: [email-masked]
> > Subject: Re: [PATCH RFC 02/10] dpaa_eth: add support for DPAA Ethernet
> > 
> > On Mon, 2015-07-20 at 09:54 +0200, Joakim Tjernlund wrote:
> > > On Wed, 2015-04-01 at 19:19 +0300, Madalin Bucur wrote:
> > > > This introduces the Freescale Data Path Acceleration Architecture
> > > > (DPAA) Ethernet driver (dpaa_eth) that builds upon the DPAA QMan,
> > > > BMan, PAMU and FMan drivers to deliver Ethernet connectivity on
> > > > the Freescale DPAA QorIQ platforms.
> > > > 
> > > > Signed-off-by: Madalin Bucur <[email-masked]>
> > > > ---
> > > ....
> > > > +	snprintf(net_dev->name, IFNAMSIZ, "fm%d-mac%d",
> > > > +		 dpa_mac_fman_index_get(pdev),
> > > > +		 dpa_mac_hw_index_get(pdev));
> > > 
> > > Should ethernet drivers dictate interface name in user space nowadays?
> > > I would prefer if you didn't.
> 
> The preformatted interface name was thought as a helper for quick interface
> identification. It also ensures constant naming of the interfaces, i.e. if you
> add/remove PCI network cards. One can make use of udev rules to override
> default interface names ("eth%d") in userspace.

I am not well versed in ethernet interface naming but I think you are just creating
another name space here. To me one either have the old eth%d names or let udev do
the naming so there is some order w.r.t interface naming.

I also find it handy to be able to control which I/F is eth0 etc. just by changing
the order they are listed in the device tree. This makes our application happy :)

> 
> Another reason for using this is that the interface name was also used for the
> debugfs file name and when compiling dpaa_eth as a module there was a
> problem with udev concurrently renaming interfaces from eth0 to something
> like fmx-macy, making the next probed DPAA interface temporarily get the
> eth0 name (before being renamed fmx-macw). Subsequently,
> the debugfs_create_file(net_dev->name,...) call failed because of duplicated
> names.
> 
> If this is considered more of a bug than a feature, I can remove it and only change
> the naming of the debugfs entries to avoid the udev issue.

Perhaps netdev list can advise?

 Jocke